<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Mu - apps/colors.mu</title>
<meta name="Generator" content="Vim/8.2">
<meta name="plugin-version" content="vim8.1_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,pre_wrap,no_foldcolumn,expand_tabs,line_ids,prevent_copy=,use_input_for_pc=fallback">
<meta name="colorscheme" content="minimal-light">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #000000; background-color: #ffffd7; }
body { font-size:12pt; font-family: monospace; color: #000000; background-color: #ffffd7; }
a { color:inherit; }
* { font-size:12pt; font-size: 1em; }
.PreProc { color: #c000c0; }
.muRegEdx { color: #af5f00; }
.Special { color: #ff6060; }
.LineNr { }
.muRegEsi { color: #005faf; }
.muRegEbx { color: #5f00ff; }
.Constant { color: #008787; }
.muRegEcx { color: #870000; }
.Delimiter { color: #c000c0; }
.muFunction { color: #af5f00; text-decoration: underline; }
.CommentedCode { color: #8a8a8a; }
.muComment { color: #005faf; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<a href='https://github.com/akkartik/mu/blob/main/apps/colors.mu'>https://github.com/akkartik/mu/blob/main/apps/colors.mu</a>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span><span class="muComment"># Return colors 'near' a given r/g/b value (expressed in hex)</span>
<span id="L2" class="LineNr">  2 </span><span class="muComment"># If we did this rigorously we'd need to implement cosines. So we won't.</span>
<span id="L3" class="LineNr">  3 </span><span class="muComment">#</span>
<span id="L4" class="LineNr">  4 </span><span class="muComment"># To build:</span>
<span id="L5" class="LineNr">  5 </span><span class="muComment">#   $ ./translate apps/colors.mu</span>
<span id="L6" class="LineNr">  6 </span><span class="muComment">#</span>
<span id="L7" class="LineNr">  7 </span><span class="muComment"># Example session:</span>
<span id="L8" class="LineNr">  8 </span><span class="muComment">#   $ qemu-system-i386 code.img</span>
<span id="L9" class="LineNr">  9 </span><span class="muComment">#   Enter 3 hex bytes for r, g, b (lowercase; no 0x prefix) separated by a single space&gt; aa 0 aa</span>
<span id="L10" class="LineNr"> 10 </span><span class="muComment">#   5</span>
<span id="L11" class="LineNr"> 11 </span><span class="muComment"># This means only color 5 in the default palette is similar to #aa00aa.</span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='colors.mu.html#L13'>main</a></span> <a href='../500fake-screen.mu.html#L16'>screen</a>: (addr <a href='../500fake-screen.mu.html#L16'>screen</a>), keyboard: (addr keyboard), data-disk: (addr disk) <span class="Delimiter">{</span>
<span id="L14" class="LineNr"> 14 </span>  <span class="PreProc">var</span> in-storage: (stream byte <span class="Constant">0x10</span>)
<span id="L15" class="LineNr"> 15 </span>  <span class="PreProc">var</span> in/<span class="muRegEsi">esi</span>: (addr stream byte) <span class="Special">&lt;-</span> address in-storage
<span id="L16" class="LineNr"> 16 </span>  <span class="Delimiter">{</span>
<span id="L17" class="LineNr"> 17 </span>    <span class="muComment"># print prompt</span>
<span id="L18" class="LineNr"> 18 </span>    <span class="PreProc">var</span> x/eax: int <span class="Special">&lt;-</span> <a href='../501draw-text.mu.html#L106'>draw-text-rightward</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">&quot;Enter 3 hex bytes for r, g, b (lowercase; no 0x prefix) separated by a single space&gt; &quot;</span>, <span class="Constant">0x10</span>/x, <span class="Constant">0x80</span>/xmax, <span class="Constant">0x28</span>/y, <span class="Constant">3</span>/fg/cyan, <span class="Constant">0</span>/bg
<span id="L19" class="LineNr"> 19 </span>    <span class="muComment"># read line from keyboard</span>
<span id="L20" class="LineNr"> 20 </span>    <a href='../106stream.subx.html#L20'>clear-stream</a> in
<span id="L21" class="LineNr"> 21 </span>    <span class="Delimiter">{</span>
<span id="L22" class="LineNr"> 22 </span>      <a href='../500fake-screen.mu.html#L316'>draw-cursor</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">0x20</span>/space
<span id="L23" class="LineNr"> 23 </span>      <span class="PreProc">var</span> key/eax: byte <span class="Special">&lt;-</span> <a href='../102keyboard.subx.html#L21'>read-key</a> keyboard
<span id="L24" class="LineNr"> 24 </span>      compare key, <span class="Constant">0xa</span>/newline
<span id="L25" class="LineNr"> 25 </span>      <span class="PreProc">break-if-=</span>
<span id="L26" class="LineNr"> 26 </span>      compare key, <span class="Constant">0</span>
<span id="L27" class="LineNr"> 27 </span>      <span class="PreProc">loop-if-=</span>
<span id="L28" class="LineNr"> 28 </span>      <span class="PreProc">var</span> key2/eax: int <span class="Special">&lt;-</span> copy key
<span id="L29" class="LineNr"> 29 </span>      <a href='../115write-byte.subx.html#L12'>append-byte</a> in, key2
<span id="L30" class="LineNr"> 30 </span>      <span class="PreProc">var</span> c/eax: code-point <span class="Special">&lt;-</span> copy key2  <span class="muComment"># TODO: unicode input</span>
<span id="L31" class="LineNr"> 31 </span>      <a href='../501draw-text.mu.html#L84'>draw-code-point-at-cursor-over-full-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, c, <span class="Constant">0xf</span>/fg, <span class="Constant">0</span>/bg
<span id="L32" class="LineNr"> 32 </span>      <span class="PreProc">loop</span>
<span id="L33" class="LineNr"> 33 </span>    <span class="Delimiter">}</span>
<span id="L34" class="LineNr"> 34 </span>    <a href='../500fake-screen.mu.html#L330'>clear-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>
<span id="L35" class="LineNr"> 35 </span>    <span class="muComment"># parse</span>
<span id="L36" class="LineNr"> 36 </span>    <span class="PreProc">var</span> a/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L37" class="LineNr"> 37 </span>    <span class="PreProc">var</span> b/<span class="muRegEdx">edx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L38" class="LineNr"> 38 </span>    <span class="PreProc">var</span> c/<span class="muRegEbx">ebx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L39" class="LineNr"> 39 </span>    <span class="muComment"># a, b, c = r, g, b</span>
<span id="L40" class="LineNr"> 40 </span>    a, b, c <span class="Special">&lt;-</span> <a href='colors.mu.html#L64'>parse</a> in
<span id="L41" class="LineNr"> 41 </span><span class="CommentedCode">#?     set-cursor-position screen, 0x10/x, 0x1a/y</span>
<span id="L42" class="LineNr"> 42 </span><span class="CommentedCode">#?     draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, a, 7/fg, 0/bg</span>
<span id="L43" class="LineNr"> 43 </span><span class="CommentedCode">#?     draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L44" class="LineNr"> 44 </span><span class="CommentedCode">#?     draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, b, 7/fg, 0/bg</span>
<span id="L45" class="LineNr"> 45 </span><span class="CommentedCode">#?     draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L46" class="LineNr"> 46 </span><span class="CommentedCode">#?     draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, c, 7/fg, 0/bg</span>
<span id="L47" class="LineNr"> 47 </span>    a, b, c <span class="Special">&lt;-</span> <a href='../505colors.mu.html#L51'>hsl</a> a, b, c
<span id="L48" class="LineNr"> 48 </span>    <span class="muComment"># return all colors in the same quadrant in h, s and l</span>
<span id="L49" class="LineNr"> 49 </span>    <a href='colors.mu.html#L188'>print-nearby-colors</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, a, b, c
<span id="L50" class="LineNr"> 50 </span>    <span class="muComment"># another metric</span>
<span id="L51" class="LineNr"> 51 </span>    <span class="PreProc">var</span> color/eax: int <span class="Special">&lt;-</span> <a href='../505colors.mu.html#L260'>nearest-color-euclidean-hsl</a> a, b, c
<span id="L52" class="LineNr"> 52 </span>    <a href='../500fake-screen.mu.html#L269'>set-cursor-position</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">0x10</span>/x, <span class="Constant">0x26</span>/y
<span id="L53" class="LineNr"> 53 </span>    <a href='../501draw-text.mu.html#L332'>draw-text-wrapping-right-then-down-from-cursor-over-full-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">&quot;nearest (euclidean, h/s/l): &quot;</span>, <span class="Constant">0xf</span>/fg, <span class="Constant">0</span>/bg
<span id="L54" class="LineNr"> 54 </span>    <a href='../501draw-text.mu.html#L442'>draw-int32-decimal-wrapping-right-then-down-from-cursor-over-full-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, color, <span class="Constant">7</span>/fg, <span class="Constant">0</span>/bg
<span id="L55" class="LineNr"> 55 </span>    <a href='../501draw-text.mu.html#L332'>draw-text-wrapping-right-then-down-from-cursor-over-full-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">&quot; &quot;</span>, <span class="Constant">0xf</span>/fg, <span class="Constant">0</span>/bg
<span id="L56" class="LineNr"> 56 </span>    <a href='../501draw-text.mu.html#L332'>draw-text-wrapping-right-then-down-from-cursor-over-full-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">&quot;               &quot;</span>, <span class="Constant">0</span>/fg, color
<span id="L57" class="LineNr"> 57 </span>    <span class="muComment">#</span>
<span id="L58" class="LineNr"> 58 </span>    <span class="PreProc">loop</span>
<span id="L59" class="LineNr"> 59 </span>  <span class="Delimiter">}</span>
<span id="L60" class="LineNr"> 60 </span><span class="Delimiter">}</span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span><span class="muComment"># read exactly 3 words in a single line</span>
<span id="L63" class="LineNr"> 63 </span><span class="muComment"># Each word consists of exactly 1 or 2 hex bytes. No hex prefix.</span>
<span id="L64" class="LineNr"> 64 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='colors.mu.html#L64'>parse</a></span> in: (addr stream byte)<span class="PreProc"> -&gt; </span>_/<span class="muRegEcx">ecx</span>: int, _/<span class="muRegEdx">edx</span>: int, _/<span class="muRegEbx">ebx</span>: int <span class="Delimiter">{</span>
<span id="L65" class="LineNr"> 65 </span>  <span class="muComment"># read first byte of r</span>
<span id="L66" class="LineNr"> 66 </span>  <span class="PreProc">var</span> tmp/eax: byte <span class="Special">&lt;-</span> <a href='../112read-byte.subx.html#L13'>read-byte</a> in
<span id="L67" class="LineNr"> 67 </span>  <span class="Delimiter">{</span>
<span id="L68" class="LineNr"> 68 </span>    <span class="PreProc">var</span> valid?/eax: boolean <span class="Special">&lt;-</span> <a href='../118parse-hex-int.subx.html#L701'>hex-digit?</a> tmp
<span id="L69" class="LineNr"> 69 </span>    compare valid?, <span class="Constant">0</span>/false
<span id="L70" class="LineNr"> 70 </span>    <span class="PreProc">break-if-!=</span>
<span id="L71" class="LineNr"> 71 </span>    <a href='../317abort.subx.html#L5'>abort</a> <span class="Constant">&quot;invalid byte 0 of r&quot;</span>
<span id="L72" class="LineNr"> 72 </span>  <span class="Delimiter">}</span>
<span id="L73" class="LineNr"> 73 </span>  tmp <span class="Special">&lt;-</span> <a href='colors.mu.html#L175'>fast-hex-digit-value</a> tmp
<span id="L74" class="LineNr"> 74 </span>  <span class="PreProc">var</span> r/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy tmp
<span id="L75" class="LineNr"> 75 </span><span class="CommentedCode">#?   set-cursor-position 0/screen, 0x10/x, 0x10/y</span>
<span id="L76" class="LineNr"> 76 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, r, 7/fg, 0/bg</span>
<span id="L77" class="LineNr"> 77 </span>  <span class="muComment"># read second byte of r</span>
<span id="L78" class="LineNr"> 78 </span>  tmp <span class="Special">&lt;-</span> <a href='../112read-byte.subx.html#L13'>read-byte</a> in
<span id="L79" class="LineNr"> 79 </span>  <span class="Delimiter">{</span>
<span id="L80" class="LineNr"> 80 </span>    <span class="Delimiter">{</span>
<span id="L81" class="LineNr"> 81 </span>      <span class="PreProc">var</span> valid?/eax: boolean <span class="Special">&lt;-</span> <a href='../118parse-hex-int.subx.html#L701'>hex-digit?</a> tmp
<span id="L82" class="LineNr"> 82 </span>      compare valid?, <span class="Constant">0</span>/false
<span id="L83" class="LineNr"> 83 </span>    <span class="Delimiter">}</span>
<span id="L84" class="LineNr"> 84 </span>    <span class="PreProc">break-if-=</span>
<span id="L85" class="LineNr"> 85 </span>    r <span class="Special">&lt;-</span> shift-left <span class="Constant">4</span>
<span id="L86" class="LineNr"> 86 </span>    tmp <span class="Special">&lt;-</span> <a href='colors.mu.html#L175'>fast-hex-digit-value</a> tmp
<span id="L87" class="LineNr"> 87 </span><span class="CommentedCode">#?     {</span>
<span id="L88" class="LineNr"> 88 </span><span class="CommentedCode">#?       var foo/eax: int &lt;- copy tmp</span>
<span id="L89" class="LineNr"> 89 </span><span class="CommentedCode">#?       set-cursor-position 0/screen, 0x10/x, 0x11/y</span>
<span id="L90" class="LineNr"> 90 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, foo, 7/fg, 0/bg</span>
<span id="L91" class="LineNr"> 91 </span><span class="CommentedCode">#?     }</span>
<span id="L92" class="LineNr"> 92 </span>    r <span class="Special">&lt;-</span> add tmp
<span id="L93" class="LineNr"> 93 </span><span class="CommentedCode">#?     {</span>
<span id="L94" class="LineNr"> 94 </span><span class="CommentedCode">#?       set-cursor-position 0/screen, 0x10/x, 0x12/y</span>
<span id="L95" class="LineNr"> 95 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, r, 7/fg, 0/bg</span>
<span id="L96" class="LineNr"> 96 </span><span class="CommentedCode">#?     }</span>
<span id="L97" class="LineNr"> 97 </span>    tmp <span class="Special">&lt;-</span> <a href='../112read-byte.subx.html#L13'>read-byte</a> in  <span class="muComment"># skip space</span>
<span id="L98" class="LineNr"> 98 </span>  <span class="Delimiter">}</span>
<span id="L99" class="LineNr"> 99 </span>  <span class="muComment"># read first byte of g</span>
<span id="L100" class="LineNr">100 </span>  <span class="PreProc">var</span> tmp/eax: byte <span class="Special">&lt;-</span> <a href='../112read-byte.subx.html#L13'>read-byte</a> in
<span id="L101" class="LineNr">101 </span>  <span class="Delimiter">{</span>
<span id="L102" class="LineNr">102 </span>    <span class="PreProc">var</span> valid?/eax: boolean <span class="Special">&lt;-</span> <a href='../118parse-hex-int.subx.html#L701'>hex-digit?</a> tmp
<span id="L103" class="LineNr">103 </span>    compare valid?, <span class="Constant">0</span>/false
<span id="L104" class="LineNr">104 </span>    <span class="PreProc">break-if-!=</span>
<span id="L105" class="LineNr">105 </span>    <a href='../317abort.subx.html#L5'>abort</a> <span class="Constant">&quot;invalid byte 0 of g&quot;</span>
<span id="L106" class="LineNr">106 </span>  <span class="Delimiter">}</span>
<span id="L107" class="LineNr">107 </span>  tmp <span class="Special">&lt;-</span> <a href='colors.mu.html#L175'>fast-hex-digit-value</a> tmp
<span id="L108" class="LineNr">108 </span>  <span class="PreProc">var</span> g/<span class="muRegEdx">edx</span>: int <span class="Special">&lt;-</span> copy tmp
<span id="L109" class="LineNr">109 </span><span class="CommentedCode">#?   set-cursor-position 0/screen, 0x10/x, 0x13/y</span>
<span id="L110" class="LineNr">110 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, g, 7/fg, 0/bg</span>
<span id="L111" class="LineNr">111 </span>  <span class="muComment"># read second byte of g</span>
<span id="L112" class="LineNr">112 </span>  tmp <span class="Special">&lt;-</span> <a href='../112read-byte.subx.html#L13'>read-byte</a> in
<span id="L113" class="LineNr">113 </span>  <span class="Delimiter">{</span>
<span id="L114" class="LineNr">114 </span>    <span class="Delimiter">{</span>
<span id="L115" class="LineNr">115 </span>      <span class="PreProc">var</span> valid?/eax: boolean <span class="Special">&lt;-</span> <a href='../118parse-hex-int.subx.html#L701'>hex-digit?</a> tmp
<span id="L116" class="LineNr">116 </span>      compare valid?, <span class="Constant">0</span>/false
<span id="L117" class="LineNr">117 </span>    <span class="Delimiter">}</span>
<span id="L118" class="LineNr">118 </span>    <span class="PreProc">break-if-=</span>
<span id="L119" class="LineNr">119 </span>    g <span class="Special">&lt;-</span> shift-left <span class="Constant">4</span>
<span id="L120" class="LineNr">120 </span>    tmp <span class="Special">&lt;-</span> <a href='colors.mu.html#L175'>fast-hex-digit-value</a> tmp
<span id="L121" class="LineNr">121 </span><span class="CommentedCode">#?     {</span>
<span id="L122" class="LineNr">122 </span><span class="CommentedCode">#?       var foo/eax: int &lt;- copy tmp</span>
<span id="L123" class="LineNr">123 </span><span class="CommentedCode">#?       set-cursor-position 0/screen, 0x10/x, 0x14/y</span>
<span id="L124" class="LineNr">124 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, foo, 7/fg, 0/bg</span>
<span id="L125" class="LineNr">125 </span><span class="CommentedCode">#?     }</span>
<span id="L126" class="LineNr">126 </span>    g <span class="Special">&lt;-</span> add tmp
<span id="L127" class="LineNr">127 </span><span class="CommentedCode">#?     {</span>
<span id="L128" class="LineNr">128 </span><span class="CommentedCode">#?       set-cursor-position 0/screen, 0x10/x, 0x15/y</span>
<span id="L129" class="LineNr">129 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, g, 7/fg, 0/bg</span>
<span id="L130" class="LineNr">130 </span><span class="CommentedCode">#?     }</span>
<span id="L131" class="LineNr">131 </span>    tmp <span class="Special">&lt;-</span> <a href='../112read-byte.subx.html#L13'>read-byte</a> in  <span class="muComment"># skip space</span>
<span id="L132" class="LineNr">132 </span>  <span class="Delimiter">}</span>
<span id="L133" class="LineNr">133 </span>  <span class="muComment"># read first byte of b</span>
<span id="L134" class="LineNr">134 </span>  <span class="PreProc">var</span> tmp/eax: byte <span class="Special">&lt;-</span> <a href='../112read-byte.subx.html#L13'>read-byte</a> in
<span id="L135" class="LineNr">135 </span>  <span class="Delimiter">{</span>
<span id="L136" class="LineNr">136 </span>    <span class="PreProc">var</span> valid?/eax: boolean <span class="Special">&lt;-</span> <a href='../118parse-hex-int.subx.html#L701'>hex-digit?</a> tmp
<span id="L137" class="LineNr">137 </span>    compare valid?, <span class="Constant">0</span>/false
<span id="L138" class="LineNr">138 </span>    <span class="PreProc">break-if-!=</span>
<span id="L139" class="LineNr">139 </span>    <a href='../317abort.subx.html#L5'>abort</a> <span class="Constant">&quot;invalid byte 0 of b&quot;</span>
<span id="L140" class="LineNr">140 </span>  <span class="Delimiter">}</span>
<span id="L141" class="LineNr">141 </span>  tmp <span class="Special">&lt;-</span> <a href='colors.mu.html#L175'>fast-hex-digit-value</a> tmp
<span id="L142" class="LineNr">142 </span>  <span class="PreProc">var</span> b/<span class="muRegEbx">ebx</span>: int <span class="Special">&lt;-</span> copy tmp
<span id="L143" class="LineNr">143 </span><span class="CommentedCode">#?   set-cursor-position 0/screen, 0x10/x, 0x16/y</span>
<span id="L144" class="LineNr">144 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, b, 7/fg, 0/bg</span>
<span id="L145" class="LineNr">145 </span>  <span class="muComment"># read second byte of b</span>
<span id="L146" class="LineNr">146 </span>  <span class="Delimiter">{</span>
<span id="L147" class="LineNr">147 </span>    <span class="Delimiter">{</span>
<span id="L148" class="LineNr">148 </span>      <span class="PreProc">var</span> done?/eax: boolean <span class="Special">&lt;-</span> <a href='../309stream.subx.html#L6'>stream-empty?</a> in
<span id="L149" class="LineNr">149 </span>      compare done?, <span class="Constant">0</span>/false
<span id="L150" class="LineNr">150 </span>    <span class="Delimiter">}</span>
<span id="L151" class="LineNr">151 </span>    <span class="PreProc">break-if-!=</span>
<span id="L152" class="LineNr">152 </span>    tmp <span class="Special">&lt;-</span> <a href='../112read-byte.subx.html#L13'>read-byte</a> in
<span id="L153" class="LineNr">153 </span>    <span class="Delimiter">{</span>
<span id="L154" class="LineNr">154 </span>      <span class="PreProc">var</span> valid?/eax: boolean <span class="Special">&lt;-</span> <a href='../118parse-hex-int.subx.html#L701'>hex-digit?</a> tmp
<span id="L155" class="LineNr">155 </span>      compare valid?, <span class="Constant">0</span>/false
<span id="L156" class="LineNr">156 </span>    <span class="Delimiter">}</span>
<span id="L157" class="LineNr">157 </span>    <span class="PreProc">break-if-=</span>
<span id="L158" class="LineNr">158 </span>    b <span class="Special">&lt;-</span> shift-left <span class="Constant">4</span>
<span id="L159" class="LineNr">159 </span>    tmp <span class="Special">&lt;-</span> <a href='colors.mu.html#L175'>fast-hex-digit-value</a> tmp
<span id="L160" class="LineNr">160 </span><span class="CommentedCode">#?     {</span>
<span id="L161" class="LineNr">161 </span><span class="CommentedCode">#?       var foo/eax: int &lt;- copy tmp</span>
<span id="L162" class="LineNr">162 </span><span class="CommentedCode">#?       set-cursor-position 0/screen, 0x10/x, 0x17/y</span>
<span id="L163" class="LineNr">163 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, foo, 7/fg, 0/bg</span>
<span id="L164" class="LineNr">164 </span><span class="CommentedCode">#?     }</span>
<span id="L165" class="LineNr">165 </span>    b <span class="Special">&lt;-</span> add tmp
<span id="L166" class="LineNr">166 </span><span class="CommentedCode">#?     {</span>
<span id="L167" class="LineNr">167 </span><span class="CommentedCode">#?       set-cursor-position 0/screen, 0x10/x, 0x18/y</span>
<span id="L168" class="LineNr">168 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen 0/screen, b, 7/fg, 0/bg</span>
<span id="L169" class="LineNr">169 </span><span class="CommentedCode">#?     }</span>
<span id="L170" class="LineNr">170 </span>  <span class="Delimiter">}</span>
<span id="L171" class="LineNr">171 </span>  <span class="PreProc">return</span> r, g, b
<span id="L172" class="LineNr">172 </span><span class="Delimiter">}</span>
<span id="L173" class="LineNr">173 </span>
<span id="L174" class="LineNr">174 </span><span class="muComment"># no error checking</span>
<span id="L175" class="LineNr">175 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='colors.mu.html#L175'>fast-hex-digit-value</a></span> in: byte<span class="PreProc"> -&gt; </span>_/eax: byte <span class="Delimiter">{</span>
<span id="L176" class="LineNr">176 </span>  <span class="PreProc">var</span> result/eax: byte <span class="Special">&lt;-</span> copy in
<span id="L177" class="LineNr">177 </span>  compare result, <span class="Constant">0x39</span>
<span id="L178" class="LineNr">178 </span>  <span class="Delimiter">{</span>
<span id="L179" class="LineNr">179 </span>    <span class="PreProc">break-if-&gt;</span>
<span id="L180" class="LineNr">180 </span>    result <span class="Special">&lt;-</span> subtract <span class="Constant">0x30</span>/<span class="Constant">0</span>
<span id="L181" class="LineNr">181 </span>    <span class="PreProc">return</span> result
<span id="L182" class="LineNr">182 </span>  <span class="Delimiter">}</span>
<span id="L183" class="LineNr">183 </span>  result <span class="Special">&lt;-</span> subtract <span class="Constant">0x61</span>/a
<span id="L184" class="LineNr">184 </span>  result <span class="Special">&lt;-</span> add <span class="Constant">0xa</span>/<span class="Constant">10</span>
<span id="L185" class="LineNr">185 </span>  <span class="PreProc">return</span> result
<span id="L186" class="LineNr">186 </span><span class="Delimiter">}</span>
<span id="L187" class="LineNr">187 </span>
<span id="L188" class="LineNr">188 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='colors.mu.html#L188'>print-nearby-colors</a></span> <a href='../500fake-screen.mu.html#L16'>screen</a>: (addr <a href='../500fake-screen.mu.html#L16'>screen</a>), h: int, s: int, l: int <span class="Delimiter">{</span>
<span id="L189" class="LineNr">189 </span><span class="CommentedCode">#?   set-cursor-position screen, 0x10/x, 0x1c/y</span>
<span id="L190" class="LineNr">190 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, h, 7/fg, 0/bg</span>
<span id="L191" class="LineNr">191 </span><span class="CommentedCode">#?   draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L192" class="LineNr">192 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, s, 7/fg, 0/bg</span>
<span id="L193" class="LineNr">193 </span><span class="CommentedCode">#?   draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L194" class="LineNr">194 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, l, 7/fg, 0/bg</span>
<span id="L195" class="LineNr">195 </span>  <span class="muComment"># save just top 2 bits of each, so that we narrow down to 1/64th of the volume</span>
<span id="L196" class="LineNr">196 </span>  shift-right h, <span class="Constant">6</span>
<span id="L197" class="LineNr">197 </span>  shift-right s, <span class="Constant">6</span>
<span id="L198" class="LineNr">198 </span>  shift-right l, <span class="Constant">6</span>
<span id="L199" class="LineNr">199 </span><span class="CommentedCode">#?   set-cursor-position screen, 0x10/x, 0x1/y</span>
<span id="L200" class="LineNr">200 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, h, 7/fg, 0/bg</span>
<span id="L201" class="LineNr">201 </span><span class="CommentedCode">#?   draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L202" class="LineNr">202 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, s, 7/fg, 0/bg</span>
<span id="L203" class="LineNr">203 </span><span class="CommentedCode">#?   draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L204" class="LineNr">204 </span><span class="CommentedCode">#?   draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, l, 7/fg, 0/bg</span>
<span id="L205" class="LineNr">205 </span>  <span class="PreProc">var</span> a/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L206" class="LineNr">206 </span>  <span class="PreProc">var</span> b/<span class="muRegEdx">edx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L207" class="LineNr">207 </span>  <span class="PreProc">var</span> c/<span class="muRegEbx">ebx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L208" class="LineNr">208 </span>  <span class="PreProc">var</span> color/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L209" class="LineNr">209 </span>  <span class="PreProc">var</span> y/<span class="muRegEsi">esi</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">2</span>
<span id="L210" class="LineNr">210 </span>  <span class="Delimiter">{</span>
<span id="L211" class="LineNr">211 </span>    compare color, <span class="Constant">0x100</span>
<span id="L212" class="LineNr">212 </span>    <span class="PreProc">break-if-&gt;=</span>
<span id="L213" class="LineNr">213 </span>    a, b, c <span class="Special">&lt;-</span> <a href='../316colors.subx.html#L7'>color-rgb</a> color
<span id="L214" class="LineNr">214 </span>    a, b, c <span class="Special">&lt;-</span> <a href='../505colors.mu.html#L51'>hsl</a> a, b, c
<span id="L215" class="LineNr">215 </span>    a <span class="Special">&lt;-</span> shift-right <span class="Constant">6</span>
<span id="L216" class="LineNr">216 </span>    b <span class="Special">&lt;-</span> shift-right <span class="Constant">6</span>
<span id="L217" class="LineNr">217 </span>    c <span class="Special">&lt;-</span> shift-right <span class="Constant">6</span>
<span id="L218" class="LineNr">218 </span>    <span class="Delimiter">{</span>
<span id="L219" class="LineNr">219 </span>      compare a, h
<span id="L220" class="LineNr">220 </span>      <span class="PreProc">break-if-!=</span>
<span id="L221" class="LineNr">221 </span>      compare b, s
<span id="L222" class="LineNr">222 </span>      <span class="PreProc">break-if-!=</span>
<span id="L223" class="LineNr">223 </span>      compare c, l
<span id="L224" class="LineNr">224 </span>      <span class="PreProc">break-if-!=</span>
<span id="L225" class="LineNr">225 </span>      <a href='../500fake-screen.mu.html#L269'>set-cursor-position</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">0x10</span>/x, y
<span id="L226" class="LineNr">226 </span>      <a href='../501draw-text.mu.html#L442'>draw-int32-decimal-wrapping-right-then-down-from-cursor-over-full-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, color, <span class="Constant">7</span>/fg, <span class="Constant">0</span>/bg
<span id="L227" class="LineNr">227 </span>      <a href='../500fake-screen.mu.html#L269'>set-cursor-position</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">0x14</span>/x, y
<span id="L228" class="LineNr">228 </span>      <a href='../501draw-text.mu.html#L332'>draw-text-wrapping-right-then-down-from-cursor-over-full-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">&quot; &quot;</span>, <span class="Constant">7</span>/fg, <span class="Constant">0</span>/bg
<span id="L229" class="LineNr">229 </span>      <a href='../501draw-text.mu.html#L332'>draw-text-wrapping-right-then-down-from-cursor-over-full-screen</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, <span class="Constant">&quot;               &quot;</span>, <span class="Constant">0</span>/fg, color
<span id="L230" class="LineNr">230 </span><span class="CommentedCode">#?       draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L231" class="LineNr">231 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, a, 7/fg, 0/bg</span>
<span id="L232" class="LineNr">232 </span><span class="CommentedCode">#?       draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L233" class="LineNr">233 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, b, 7/fg, 0/bg</span>
<span id="L234" class="LineNr">234 </span><span class="CommentedCode">#?       draw-text-wrapping-right-then-down-from-cursor-over-full-screen screen, &quot; &quot;, 7/fg, 0/bg</span>
<span id="L235" class="LineNr">235 </span><span class="CommentedCode">#?       draw-int32-hex-wrapping-right-then-down-from-cursor-over-full-screen screen, c, 7/fg, 0/bg</span>
<span id="L236" class="LineNr">236 </span>      y <span class="Special">&lt;-</span> increment
<span id="L237" class="LineNr">237 </span>    <span class="Delimiter">}</span>
<span id="L238" class="LineNr">238 </span>    color <span class="Special">&lt;-</span> increment
<span id="L239" class="LineNr">239 </span>    <span class="PreProc">loop</span>
<span id="L240" class="LineNr">240 </span>  <span class="Delimiter">}</span>
<span id="L241" class="LineNr">241 </span><span class="Delimiter">}</span>
</pre>
</body>
</html>
<!-- vim: set foldmethod=manual : -->
